summaryrefslogtreecommitdiffstats
path: root/gettext-tools/tests/lang-bash
diff options
context:
space:
mode:
authorBruno Haible <bruno@clisp.org>2003-09-03 10:28:28 +0000
committerBruno Haible <bruno@clisp.org>2009-06-23 12:10:57 +0200
commit5843c292c0e8df84cd01d6c14d71b873a63cef49 (patch)
tree6670e29aa1b117a95c764c855e43bb11c9bb0c0f /gettext-tools/tests/lang-bash
parent0820c8b6e310926d6d077eb19dd18e809fd472fa (diff)
downloadexternal_gettext-5843c292c0e8df84cd01d6c14d71b873a63cef49.zip
external_gettext-5843c292c0e8df84cd01d6c14d71b873a63cef49.tar.gz
external_gettext-5843c292c0e8df84cd01d6c14d71b873a63cef49.tar.bz2
Integration test with bash.
Diffstat (limited to 'gettext-tools/tests/lang-bash')
-rwxr-xr-xgettext-tools/tests/lang-bash120
1 files changed, 120 insertions, 0 deletions
diff --git a/gettext-tools/tests/lang-bash b/gettext-tools/tests/lang-bash
new file mode 100755
index 0000000..fc66215
--- /dev/null
+++ b/gettext-tools/tests/lang-bash
@@ -0,0 +1,120 @@
+#! /bin/sh
+
+# Test of gettext facilities in the bash language.
+# Assumes an fr_FR locale is installed.
+# Assumes the following packages are installed: bash 2.0 or newer.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles prog.sh"
+cat <<\EOF > prog.sh
+#! /bin/bash
+
+# Find a way to echo strings without interpreting backslash.
+if test "X`(echo '\t') 2>/dev/null`" = 'X\t'; then
+ echo='echo'
+else
+ if test "X`(printf '%s\n' '\t') 2>/dev/null`" = 'X\t'; then
+ echo='printf %s\n'
+ else
+ echo_func () {
+ cat <<EOT
+$*
+EOT
+ }
+ echo='echo_func'
+ fi
+fi
+
+n=$1
+
+TEXTDOMAIN=prog
+export TEXTDOMAIN
+TEXTDOMAINDIR=.
+export TEXTDOMAINDIR
+
+eval_ngettext () {
+ _string=`ngettext "$1" "$2" "$3"`
+ eval _string="\"$_string\""
+ $echo "$_string"
+}
+
+$echo $"'Your command, please?', asked the waiter."
+
+$echo "`eval_ngettext "a piece of cake" "\\$n pieces of cake" $n`"
+EOF
+
+tmpfiles="$tmpfiles prog.pot"
+: ${XGETTEXT=xgettext}
+${XGETTEXT} -o prog.pot --omit-header --no-location prog.sh
+
+tmpfiles="$tmpfiles prog.ok"
+cat <<\EOF > prog.ok
+msgid "'Your command, please?', asked the waiter."
+msgstr ""
+
+#, sh-format
+msgid "a piece of cake"
+msgid_plural "$n pieces of cake"
+msgstr[0] ""
+msgstr[1] ""
+EOF
+
+: ${DIFF=diff}
+${DIFF} prog.ok prog.pot || exit 1
+
+tmpfiles="$tmpfiles fr.po"
+cat <<\EOF > fr.po
+msgid ""
+msgstr ""
+"Content-Type: text/plain; charset=ISO-8859-1\n"
+"Plural-Forms: nplurals=2; plural=(n > 1);\n"
+
+msgid "'Your command, please?', asked the waiter."
+msgstr "«Votre commande, s'il vous plait», dit le garçon."
+
+# Les gateaux allemands sont les meilleurs du monde.
+#, sh-format
+msgid "a piece of cake"
+msgid_plural "$n pieces of cake"
+msgstr[0] "un morceau de gateau"
+msgstr[1] "$n morceaux de gateau"
+EOF
+
+tmpfiles="$tmpfiles fr.po.new"
+: ${MSGMERGE=msgmerge}
+${MSGMERGE} -q -o fr.po.new fr.po prog.pot
+
+: ${DIFF=diff}
+${DIFF} fr.po fr.po.new || exit 1
+
+tmpfiles="$tmpfiles fr"
+test -d fr || mkdir fr
+test -d fr/LC_MESSAGES || mkdir fr/LC_MESSAGES
+
+: ${MSGFMT=msgfmt}
+${MSGFMT} -o fr/LC_MESSAGES/prog.mo fr.po
+
+# Test for presence of bash version 2.0 or newer.
+(bash -c :) >/dev/null 2>/dev/null \
+ || { rm -fr $tmpfiles; exit 77; }
+case `bash -c 'echo $BASH_VERSION'` in
+ [2-9].*) ;;
+ *) rm -fr $tmpfiles; exit 77;;
+esac
+
+tmpfiles="$tmpfiles prog.ok prog.out"
+: ${DIFF=diff}
+cat <<\EOF > prog.ok
+«Votre commande, s'il vous plait», dit le garçon.
+2 morceaux de gateau
+EOF
+
+: ${LOCALE_FR=fr_FR}
+LANGUAGE= LC_ALL=$LOCALE_FR bash ./prog.sh 2 > prog.out || exit 1
+${DIFF} prog.ok prog.out || exit 1
+
+rm -fr $tmpfiles
+
+exit 0